annotate scripts/build_project.sh @ 445:2b09be3fb0f2 prerelease

Re-implemented watch for build_heavy ... added .bela_common file for shared config and utilities
author Giulio Moro <giuliomoro@yahoo.it>
date Sun, 19 Jun 2016 03:28:53 +0100
parents a9af964ac18a
children 86591d203c78
rev   line source
giuliomoro@425 1 #!/bin/sh
andrewm@58 2 #
giuliomoro@377 3 # This script compiles a Bela project on the BeagleBone Black and
andrewm@58 4 # optionally runs it. Pass a directory path in the first argument.
andrewm@58 5 # The source files in this directory are copied to the board and compiled.
andrewm@58 6
giuliomoro@262 7 # set defaults unless variables are already set
giuliomoro@445 8
giuliomoro@445 9 [ -f ".bela_common" ] && echo "loading bela_common" || { echo "Error: cannot find .bela_common . Make sure you run the script from within the scripts/ folder"; exit 1; }
giuliomoro@445 10 source .bela_common
andrewm@58 11
giuliomoro@430 12 usage()
andrewm@58 13 {
andrewm@58 14 THIS_SCRIPT=`basename "$0"`
giuliomoro@369 15 echo "Usage: $THIS_SCRIPT [-c command-line-args] [-nbfF] <directory-with-source-files>"
andrewm@58 16 echo "
andrewm@58 17 This script copies a directory of source files to the BeagleBone, compiles
giuliomoro@377 18 and runs it. The Bela core files should have first been copied over
giuliomoro@377 19 using the setup_board.sh script supplied with Bela.
andrewm@58 20
andrewm@58 21 The source directory should contain at least one .c, .cpp or .S file.
andrewm@58 22 If the argument -n is passed, the output will not be run after compiling.
giuliomoro@369 23 The -c option passes command-line arguments to
giuliomoro@377 24 the Bela program; enclose the argument string in quotes.
andrewm@90 25
giuliomoro@425 26 -p arg : sets the name of the project to run (default: $BBB_PROJECT_NAME )
giuliomoro@439 27 -r arg : additional folder which contents will be copied to the destination folder. Use this, e.g.: for audio files or Pd/pyo sources
giuliomoro@439 28
giuliomoro@263 29 By default, the project runs in the foreground of the current terminal,
giuliomoro@369 30 within a screen session that can be detached later. The -f argument runs
giuliomoro@263 31 the project in the foreground of the current terminal, without screen, so
giuliomoro@369 32 the output can be piped to another destination. The -b argument runs it
giuliomoro@370 33 in a screen in the background, so no output is shown. The -m argument allows
giuliomoro@370 34 to pass arguments to the Makefile before the run target. For instance,
giuliomoro@425 35 pass -m \`"projectclean"\` or \`-m "distclean"\` to clean project-specific
giuliomoro@425 36 pre-built objects, or all the pre-built objects, respectively."
andrewm@58 37 }
andrewm@58 38
andrewm@58 39 OPTIND=1
andrewm@58 40
giuliomoro@439 41 while getopts "bc:m:nfFhp:r:b" opt; do
andrewm@58 42 case $opt in
andrewm@60 43 c) COMMAND_ARGS=$OPTARG
andrewm@60 44 ;;
giuliomoro@369 45 b) RUN_IN_FOREGROUND=0
giuliomoro@277 46 ;;
giuliomoro@369 47 f) RUN_WITHOUT_SCREEN=1
giuliomoro@277 48 ;;
andrewm@58 49 n) RUN_PROJECT=0
andrewm@58 50 ;;
giuliomoro@277 51 p) BBB_PROJECT_NAME=$OPTARG
giuliomoro@277 52 ;;
giuliomoro@439 53 r) ADDITIONAL_PATH=$OPTARG
giuliomoro@439 54 ;;
giuliomoro@370 55 m) BBB_MAKEFILE_OPTIONS=$OPTARG
giuliomoro@370 56 ;;
andrewm@58 57 h|\?) usage
andrewm@58 58 exit 1
andrewm@58 59 esac
andrewm@58 60 done
andrewm@58 61
andrewm@58 62 shift $((OPTIND-1))
andrewm@58 63
giuliomoro@439 64 #Only include all the files if the provided path is not empty
giuliomoro@439 65 [ -z "$ADDITIONAL_PATH" ] || ADDITIONAL_PATH="$ADDITIONAL_PATH/*"
giuliomoro@439 66
andrewm@58 67 # Check that we have a directory containing at least one source file
andrewm@58 68 # as an argument
giuliomoro@64 69
andrewm@58 70 if [ -z "$1" ]
andrewm@58 71 then
andrewm@58 72 usage
andrewm@58 73 exit
andrewm@58 74 fi
andrewm@58 75
giuliomoro@64 76 FIND_STRING="find $* -maxdepth 10000 -type f "
giuliomoro@64 77
giuliomoro@64 78 C_FILES=$($FIND_STRING -name "*.c")
giuliomoro@64 79 CPP_FILES=$($FIND_STRING -name "*.cpp")
giuliomoro@64 80 ASM_FILES=$($FIND_STRING -name "*.S")
andrewm@58 81
giuliomoro@439 82 if [ -z "$C_FILES" ] && [ -z "$CPP_FILES" ] && [ -z "$ASM_FILES" ]
andrewm@58 83 then
andrewm@58 84 echo "Please provide a directory containing .c, .cpp or .S files."
andrewm@58 85 # echo "Usage: $THIS_SCRIPT [directory-with-source-files]"
andrewm@58 86 usage
andrewm@58 87 exit
andrewm@58 88 fi
andrewm@58 89
giuliomoro@275 90 BBB_PROJECT_FOLDER=$BBB_PROJECT_HOME"/"$BBB_PROJECT_NAME #make sure there is no trailing slash here
giuliomoro@266 91 BBB_NETWORK_TARGET_FOLDER=$BBB_ADDRESS:$BBB_PROJECT_FOLDER
giuliomoro@266 92
giuliomoro@369 93 echo "Stopping running process..."
giuliomoro@369 94 # sets the date and stop running process
giuliomoro@443 95 ssh $BBB_ADDRESS "date -s \"`date '+%Y%m%d %T %Z'`\" > /dev/null; mkdir -p $BBB_PROJECT_FOLDER; make QUIET=true --no-print-directory -C $BBB_BELA_HOME stop"
giuliomoro@64 96
giuliomoro@64 97 #concatenate arguments to form path.
giuliomoro@264 98 HOST_SOURCE_PATH= #initially empty, will be filled with input arguments
giuliomoro@64 99 for i in "$@" #parse input arguments
giuliomoro@64 100 do
giuliomoro@275 101 HOST_SOURCE_PATH+=" $1"
giuliomoro@64 102 shift
giuliomoro@64 103 # Copy new souce files to the board
giuliomoro@64 104 done
andrewm@58 105
andrewm@58 106 # Copy new source files to the board
andrewm@58 107 echo "Copying new source files to BeagleBone..."
giuliomoro@439 108 if [ -z "`which rsync`" ];
giuliomoro@264 109 then
giuliomoro@264 110 #if rsync is not available, brutally clean the destination folder
giuliomoro@264 111 #and copy over all the files again and recompile them
giuliomoro@435 112 ssh bbb "make --no-print-directory -C $BBB_BELA_HOME sourceclean PROJECT=$BBB_PROJECT_NAME";
giuliomoro@439 113 scp -r $HOST_SOURCE_PATH $ADDITIONAL_PATH "$BBB_NETWORK_TARGET_FOLDER"
giuliomoro@264 114 else
giuliomoro@369 115 #rsync
giuliomoro@369 116 # --delete makes sure it removes files that are not in the origin folder
giuliomoro@369 117 # -c evaluates changes using md5 checksum instead of file date, so we don't care about time skews
giuliomoro@369 118 # --no-t makes sure file timestamps are not preserved, so that the Makefile will not think that targets are up to date when replacing files on the BBB
giuliomoro@369 119 # with older files from the host. This will solve 99% of the issues with Makefile thinking a target is up to date when it is not.
giuliomoro@439 120 rsync -ac --out-format=" %n" --no-t --delete-after --exclude=$BBB_PROJECT_NAME --exclude=build $HOST_SOURCE_PATH"/" $ADDITIONAL_PATH "$BBB_NETWORK_TARGET_FOLDER/" #trailing slashes used here make sure rsync does not create another folder inside the target folder
giuliomoro@264 121 fi;
giuliomoro@64 122
giuliomoro@64 123 if [ $? -ne 0 ]
giuliomoro@64 124 then
giuliomoro@64 125 echo "Error while copying files"
giuliomoro@64 126 exit
giuliomoro@64 127 fi
andrewm@58 128
giuliomoro@377 129 # Make new Bela executable and run
giuliomoro@439 130 MAKE_COMMAND="make --no-print-directory QUIET=true -C $BBB_BELA_HOME PROJECT='$BBB_PROJECT_NAME' CL='$COMMAND_ARGS' $BBB_MAKEFILE_OPTIONS"
andrewm@58 131 if [ $RUN_PROJECT -eq 0 ]
andrewm@58 132 then
andrewm@58 133 echo "Building project..."
giuliomoro@323 134 ssh $BBB_ADDRESS "$MAKE_COMMAND"
andrewm@58 135 else
andrewm@58 136 echo "Building and running project..."
andrewm@90 137
andrewm@90 138 if [ $RUN_WITHOUT_SCREEN -ne 0 ]
andrewm@90 139 then
giuliomoro@330 140 ssh -t $BBB_ADDRESS "$MAKE_COMMAND run"
andrewm@90 141 elif [ $RUN_IN_FOREGROUND -eq 0 ]
andrewm@90 142 then
giuliomoro@323 143 ssh $BBB_ADDRESS "$MAKE_COMMAND runscreen"
andrewm@90 144 else
giuliomoro@323 145 ssh -t $BBB_ADDRESS "$MAKE_COMMAND runscreenfg"
andrewm@90 146 fi
giuliomoro@249 147 fi